<script setup>
import { computed } from "vue";
import { useDataLinkStore } from "@/stores/useDataLinkStore";
import ToolChooser from "@/components/ToolChooser.vue";
import DataChooser from "@/components/DataChooser.vue";
import { useToolStore } from "~~/stores/useToolStore";
import { useISAStore } from "~~/stores/useISAStore";
import TreePreview from "@/components/TreePreview.vue";

const ToolStore = useToolStore();
const ISAStore = useISAStore();
const currentStep = ref("selectConnector");
const selectedTool = ref(null);
const importParent = ref("");
const items = ref(null);
const spinner = ref(false);
const dialogExitConfirmation = ref(false);
const currentDataObjects = ref(null);
const isatype = ref(null);

// declare prop for v-model attribute
const props = defineProps([
  "modelValue",
  "isaObject",
  "investigationId",
  "studyId",
]);
const emit = defineEmits(["update:modelValue"]);
const value = computed({
  get() {
    return props.modelValue;
  },
  set(value) {
    emit("update:modelValue", value);
  },
});
watch(value, async (newValue, oldValue) => {
  if (newValue) {
    //dialog is open
    selectedTool.value = null;
    currentStep.value = "selectConnector";
  }
});

async function closeDialog() {
  if (currentStep.value == "selectConnector") {
    value.value = false;
  } else {
    dialogExitConfirmation.value = true;
  }
}

async function onToolSelected(tool) {
  selectedTool.value = tool;
  currentStep.value = "chooseDataObject";
  currentDataObjects.value = null;
}

async function setcurrentStep(step) {
  currentStep.value = step;
}

async function onUsedDataObject(usedDataObject) {
  currentStep.value = "sumUpImport";
  items.value = null;
  isatype.value = null;
  importParent.value = usedDataObject;
  if (props.isaObject.studies) {
    var data = await ISAStore.updateInvestigationByImport(
      selectedTool.value,
      importParent.value,
      props.isaObject,
      true
    );
    isatype.value = "Investigation";
  } else if (props.isaObject.assays) {
    var data = await ISAStore.updateStudyByImport(
      selectedTool.value,
      importParent.value,
      props.investigationId,
      props.isaObject,
      true
    );
    isatype.value = "Study";
  } else {
    var data = await ISAStore.updateAssayByImport(
      selectedTool.value,
      importParent.value,
      props.investigationId,
      props.studyId,
      props.isaObject,
      true
    );
    isatype.value = "Assay";
  }
  items.value = data;
}

async function onImportDataObjects() {
  spinner.value = true;
  if (props.isaObject.studies) {
    await ISAStore.updateInvestigationByImport(
      selectedTool.value,
      importParent.value,
      props.isaObject,
      false
    );
  } else if (props.isaObject.assays) {
    await ISAStore.updateStudyByImport(
      selectedTool.value,
      importParent.value,
      props.investigationId,
      props.isaObject,
      false
    );
  } else {
    await ISAStore.updateAssayByImport(
      selectedTool.value,
      importParent.value,
      props.investigationId,
      props.studyId,
      props.isaObject,
      false
    );
  }
  value.value = false;
}
</script>

<template>
  <v-dialog width="1000" v-model="value" scrollable persistent>
    <v-card>
      <v-card-title v-if="selectedTool == null" class="d-flex">
        <v-sheet class="me-auto">Import from ...</v-sheet>
        <v-sheet
          ><v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="closeDialog"
          ></v-btn
        ></v-sheet>
      </v-card-title>
      <v-card-title v-if="selectedTool != null">
        Import from {{ selectedTool.name }}
      </v-card-title>
      <v-card-text style="height: 500px">
        <v-container class="fill-height">
          <ToolChooser
            connectorType="isaimporter"
            :investigationId="props.investigationId"
            @toolselected="onToolSelected"
            v-if="currentStep == 'selectConnector'"
          />
          <v-row class="fill-height" v-if="currentStep == 'chooseDataObject'">
            <DataChooser
              buttonTitle="Import"
              :selectedTool="selectedTool"
              @currentStep="setcurrentStep"
              @usedDataObject="onUsedDataObject"
            />
          </v-row>
          <v-row class="fill-height" v-if="currentStep == 'sumUpImport'">
            <v-col class="d-flex flex-column fill-height">
              <div>
                <div class="d-flex flex-row align-center">
                  <b>Import Summary</b>
                </div>
                <v-divider></v-divider>
              </div>
              <div class="overflow-y-auto">
                <v-col class="d-flex flex-column fill-height overflow-y-auto">
                  <ul v-if="items != null" style="list-style-type: none">
                    <TreePreview
                      v-if="items != null"
                      :isatype="isatype"
                      v-for="(item, index) in [items]"
                      :index="index"
                      :item="item"
                    >
                    </TreePreview>
                  </ul>

                  <div v-if="items == null">
                    <div
                      class="skeleton skeleton-text skeleton-title mb-4"
                    ></div>
                    <div class="skeleton skeleton-text"></div>
                    <div class="skeleton skeleton-text"></div>
                    <div class="skeleton skeleton-text"></div>
                  </div>
                </v-col>
              </div>

              <div class="mt-auto d-flex flex-row">
                <v-btn
                  size="small"
                  color="primary"
                  class="ml-auto"
                  @click="setcurrentStep('chooseDataObject')"
                  >Back</v-btn
                >
                <v-btn
                  v-if="spinner == false"
                  size="small"
                  color="primary"
                  class="ml-5"
                  @click="onImportDataObjects()"
                  :disabled="items == null"
                  >Import
                </v-btn>
                <v-btn
                  v-if="spinner == true"
                  size="small"
                  color="primary"
                  class="ml-5"
                >
                  <div class="spinner">
                    <div class="bounce1"></div>
                    <div class="bounce2"></div>
                    <div class="bounce3"></div>
                  </div>
                </v-btn>
              </div>
            </v-col>
            <v-divider class="mx-4" vertical></v-divider>
            <v-col cols="3" class="d-flex flex-column fill-height">
              <div>
                <p>
                  <v-icon icon="mdi-feather" size="small"></v-icon>&nbsp;
                  Investigation
                </p>
                <p>
                  <v-icon icon="mdi-notebook-outline" size="small"></v-icon
                  >&nbsp; Study
                </p>
                <p>
                  <v-icon icon="mdi-test-tube" size="small"></v-icon>&nbsp;
                  Assay
                </p>
              </div>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogExitConfirmation" width="auto">
    <v-card>
      <v-card-title>
        <v-icon color="red-darken-2" icon="mdi-chat-alert"></v-icon> Are you
        sure?
      </v-card-title>
      <v-card-text>
        You are about to leave the import procedure. Are you sure?
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="green-darken-1"
          variant="text"
          @click="dialogExitConfirmation = false"
        >
          No
        </v-btn>
        <v-btn
          color="red"
          variant="text"
          @click="
            dialogExitConfirmation = false;
            value = false;
          "
        >
          Yes
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style>
.skeleton {
  animation: skeleton-loading 1s linear infinite alternate;
}

@keyframes skeleton-loading {
  0% {
    background-color: hsl(200, 20%, 80%);
  }
  100% {
    background-color: hsl(200, 20%, 95%);
  }
}

.skeleton-text {
  width: 100%;
  height: 1.5rem;
  margin-bottom: 0.5rem;
  border-radius: 0.25rem;
}

.skeleton-title {
  width: 50%;
}

.spinner {
  margin: auto 0;
  width: 54px;
  text-align: center;
}

.spinner > div {
  width: 8px;
  height: 8px;
  background-color: #f6f8f9;

  border-radius: 100%;
  display: inline-block;
  -webkit-animation: sk-bouncedelay 1.4s infinite ease-in-out both;
  animation: sk-bouncedelay 1.4s infinite ease-in-out both;
}

.spinner .bounce1 {
  -webkit-animation-delay: -0.32s;
  animation-delay: -0.32s;
}

.spinner .bounce2 {
  -webkit-animation-delay: -0.16s;
  animation-delay: -0.16s;
}

@-webkit-keyframes sk-bouncedelay {
  0%,
  80%,
  100% {
    -webkit-transform: scale(0);
  }
  40% {
    -webkit-transform: scale(1);
  }
}

@keyframes sk-bouncedelay {
  0%,
  80%,
  100% {
    -webkit-transform: scale(0);
    transform: scale(0);
  }
  40% {
    -webkit-transform: scale(1);
    transform: scale(1);
  }
}
</style>

